import java.util.ArrayList;
import java.util.Iterator;
import java.io.ObjectOutputStream;
import java.io.FileOutputStream;
import java.io.ObjectInputStream;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.EOFException;

/**
 * Beschreiben Sie hier die Klasse Moeblierung.
 * 
 * @author claus albowski
 * @version sept 06
 */
public class Moeblierung{

    ArrayList liste;

    /**
     * Konstruktor fr Objekte der Klasse Moeblierung
     */
    public Moeblierung()
    {
        liste = new ArrayList();
    }
    
    /**
     * sichert und lscht die Darstellung.
     */
    public void sichernUndLoeschen()throws IOException{
        sichern();
        loescheAlle();
        liste = new ArrayList();
    }

    /**
     * holt und stellt alle dar.
     */
    public void holenUndZeigen()throws ClassNotFoundException, IOException{
        holen();
        zeigeAlle();
    }

    /**
     * sichern
     */
    private void sichern()
    throws IOException{
        try{
            ObjectOutputStream ausgabe= new ObjectOutputStream( new FileOutputStream("ausgabe.moe"));
            for (Iterator it= liste.iterator();it.hasNext();){
                ausgabe.writeObject(it.next());
            }
            ausgabe.close();
        } catch (FileNotFoundException e){ System.out.println("Datei existiert nicht!"); };
    }
    
    /**
     * holen
     */
    private void holen()
    throws ClassNotFoundException, IOException{
        try{
            Object o=null;
            liste = new ArrayList();
            ObjectInputStream eingabe= new ObjectInputStream( new FileInputStream("ausgabe.moe"));
            boolean fertig = false;
            while (!fertig){
                try{
                    o = eingabe.readObject();
                } catch (EOFException eofe) {fertig=true;};
                if (fertig) 
                eingabe.close();
                else liste.add(o);
            }
        } catch (FileNotFoundException e){ System.out.println("Datei existiert nicht!"); };
    }
    
       
    /**
     * erzeugt einen Stuhl und zeigt ihn.
     */
    public void erzeugeStuhl()
    {
        Stuhl stuhl=new Stuhl();
        liste.add(stuhl);
        stuhl.zeige();
    }
    
    /**
     * erzeugt einen Tisch und zeigt ihn.
     */
    public void erzeugeTisch()
    {
        Tisch tisch=new Tisch();
        liste.add(tisch);
        tisch.zeige();
    }
    
    /**
     * zeigt die gesamte Mbelliste an.
     */
    private void zeigeAlle(){
        Moebel moebel;
        for (Iterator it= liste.iterator();it.hasNext();){
            moebel= (Moebel)it.next();
            moebel.zeige();
        }
    }
    
    /**
     * lscht die dargestellte Mbelliste.
     */
    private void loescheAlle(){
        Moebel moebel;
        for (Iterator it= liste.iterator();it.hasNext();){
            moebel= (Moebel)it.next();
            moebel.verberge();
        }
    }
}
